<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "partner_site_params".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "PartnerSiteParams".
 *
 * Columns in table "partner_site_params" available as properties of the model,
 * followed by relations of table "partner_site_params" available as properties of the model.
 *
 * @property integer $id
 * @property integer $partner_site_id
 * @property integer $provider_id
 * @property integer $practice_id
 * @property string $param_name
 * @property string $param_value
 * @property string $date_added
 * @property string $date_updated
 *
 * @property PartnerSite $partnerSite
 * @property Provider $provider
 * @property Practice $practice
 */
abstract class BasePartnerSiteParams extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'partner_site_params';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'PartnerSiteParams|PartnerSiteParams', $n);
    }

    public static function representingColumn()
    {
        return 'param_name';
    }

    public function rules()
    {
        return array(
            array('partner_site_id, provider_id, practice_id', 'numerical', 'integerOnly' => true),
            array('param_name', 'length', 'max' => 50),
            array('param_value', 'length', 'max' => 255),
            array('date_added, date_updated', 'safe'),
            array('partner_site_id, provider_id, practice_id, param_name, param_value, date_added, date_updated',
                'default', 'setOnEmpty' => true, 'value' => null),
            array('id, partner_site_id, provider_id, practice_id, param_name, param_value, date_added, date_updated',
                'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'partnerSite' => array(self::BELONGS_TO, 'PartnerSite', 'partner_site_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'partner_site_id' => null,
            'provider_id' => null,
            'practice_id' => null,
            'param_name' => Yii::t('app', 'Param Name'),
            'param_value' => Yii::t('app', 'Param Value'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Udpated'),
            'partnerSite' => null,
            'provider' => null,
            'practice' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('partner_site_id', $this->partner_site_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('param_name', $this->param_name, true);
        $criteria->compare('param_value', $this->param_value, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
